<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @subpackage tools
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: parser.php 655 2009-04-28 05:22:28Z  $
 */

header('Content-Type: text/html; charset=windows-1251');
chdir('../');

/** zengine */
require_once 'zengine/classes/zengine.php';

/** zparser */
require_once 'tools/zparser.php';

zengine::init();

//  
$filename = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'pages.txt';
if (!file_exists($filename)) {
    echo '<pre>   pages.txt.       tools,  
 ,         txt.</pre>';
    exit;
}
if (strtolower($_SERVER['REQUEST_METHOD']) == 'post') {
    $logs = array();
    $parseFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'pages.txt.' . date('YmdHis');
    if (!rename($filename, $parseFile)) {
        $logs[] = '    pages.txt';
        $parseFile = $filename;
    }

    $config = new zconfig('parser.ini');

    $parser = new zparser();
    //      
    $parser->setDefaultCharset($config->get('parser.charset', 'windows-1251'));
    //      (text2html  asis)
    $parser->setDefaultFilter($config->get('parser.filter', 'text2html'));
    //      ,    
    $parser->forceIndex((bool) $config->get('parser.forceindex', true));
    //     
    $parser->deleteOldContent((bool) $config->get('parser.deleteold', true));
    //  
    zengine::zsource()->beginTransaction();
    $parser->parse($parseFile);
    zengine::zsource()->commit();

    //   
    zengine::zsource()->update();
    $logs += $parser->getLog();
    $logs[] = '------------';
    $logs[] = '<a href="' . zengine::getInstance()->getBaseUri() . '"> </a>';

    echo '<pre>' . implode("\r\n", $logs) . '</pre>';
} else {
    ?>
<form method="post">
<input type="submit" value=" " />
</form>
    <?php
}
