<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: text2html.php 81 2008-08-08 13:42:03Z lks $
 */

/** zfilter */
require_once 'zengine/classes/zfilter.php';

/**
 *   .    , 
 *   (, )   
 *
 * @package    zengine
 * @subpackage zfilter
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zfilter_text2html implements zfilter {
    /**
     *      HTML-.   
     *   (\r)   .
     *
     * @param string $text
     * @return string
     */
    public function filter ($text)
    {
        //     (     )
        $text = str_replace("\r", "", $text);
        //         ,   
        if (! preg_match("/\n$/", $text)) {
            $text .= "\n";
        }
        //    ,   ( )
        $text = preg_replace("/^([^\n#-][^\n]*)\n/m", "<p>$1</p>\n", $text);
        //     
        $text = preg_replace("/^<p>(<h[1-6]?>.+<\/h[1-6]?>)<\/p>$/im", "$1", $text);
        //       ,   <br />
        $text = preg_replace("/<\/p>\n<p>/", "<br />\n", $text);
        //  
        $text = $this->parseLists($text);
        $text = preg_replace('%(</?(?:ul|li|ol)>)<br />%', '$1', $text);
        $text = preg_replace('%<p>(<(?:o|u)l>)%', '$1', $text);
        $text = preg_replace('%(</(?:o|u)l>)</p>%', '$1', $text);
        return $text;
    }

    /**
     *   HTML-  
     *
     * @param string $text ,   
     * @return string
     */
    private function parseLists ($text)
    {
        //  
        //  
        if (preg_match("/^-/m", $text)) {
            $text = preg_replace("/^([#-]\s*.+)$/m", "[li]$1[/li]", $text);
            $text = preg_replace("/\[li\].+\[\/li\]/", "[ul]\n$0\n[/ul]", $text);
            $text = preg_replace("/\n\[\/ul\]\n\[ul\]/", "", $text);
            //   
            preg_match_all("/\[ul\]\n(.+)\n\[\/ul\]/Us", $text, $matches);
            foreach ($matches[1] as $matchKey => $ul) {
                // ,       
                $arLists = array();
                $textLines = explode("\n", $ul);
                $levelItem = array(&$arLists);
                $prevLevel = 0;
                $i = 0;
                foreach ($textLines as $line) {
                    $i ++;
                    $line = substr($line, 4, strlen($line) - 9);
                    $level = strspn($line, '-#') - 1;
                    //  
                    if ($level > $prevLevel) {
                        $levelItem[$level] = &$prevItem;
                    }
                    //   
                    if ($line{$level} == '-') {
                        $type = 'ul';
                    } else {
                        $type = 'ol';
                    }
                    //    
                    $line = ltrim($line, ' -#');
                    $item[$i] = array();
                    $item[$i]['text'] = $line;
                    //  
                    $levelItem[$level][$type][] = &$item[$i];
                    $prevItem = &$item[$i];
                    $prevLevel = $level;
                }
                $text = str_replace($matches[0][$matchKey], $this->_processList($arLists), $text);
            }
        }
        return $text;
    }

    /**
     *   HTML-     
     *
     * @param array $array
     * @return string
     */
    private function _processList ($array)
    {
        $result = '';
        foreach ($array as $key => $items) {
            if ($key != 'ul' && $key != 'ol') {
                continue;
            }
            $result .= "<{$key}>\n";
            foreach ($items as $item) {
                $result .= "<li>{$item['text']}";
                if (isset($item['ul']) || isset($item['ol'])) {
                    $result .= "\n" . $this->_processList($item);
                }
                $result .= "</li>\n";
            }
            $result .= "</{$key}>";
        }
        return $result;
    }
}
