<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zhelper.php 203 2008-08-30 13:08:54Z lks $
 */


/**
 * -    .    
 *   .
 *
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zhelper {
    /**
     *  ,       .
     *        .
     *
     * @param string $name
     * @param array $arguments
     * @return string
     */
    public function __call ($name, $arguments) {
        $helperClass = 'zhelper_' . $name;

        /**
         *   
         */
        if (! class_exists($helperClass, false)) {
            if (file_exists('templates/' . $this->ztemplate->getTheme() . '/helpers/' . $name . '.php')) {
                include_once 'templates/' . $this->ztemplate->getTheme() . '/helpers/' . $name . '.php';
            } elseif (file_exists('zengine/helpers/' . $name . '.php')) {
                include_once 'zengine/helpers/' . $name . '.php';
            }
            if (! class_exists($helperClass, false)) {
                return $helperClass;
            }
        }
        $helper = new $helperClass();
        foreach ($this->variables as $key => $value) {
            $helper->$key = $value;
        }
        /**
         *  
         */
        ob_start();
        call_user_func_array(array($helper, $name), $arguments);
        $content = ob_get_contents();
        ob_end_clean();
        unset($helper);
        return $content;
    }

    /**
     *   __get()
     *
     * @param string $name   
     * @return mixed
     */
    public function __get ($name) {
    	if (isset($this->variables[$name])) {
    	    return $this->variables[$name];
    	}
    	return null;
    }

    /**
     *   __set()
     *
     * @param string $name
     * @param mixed $value
     */
    public function __set ($name, $value) {
    	$this->variables[$name] = $value;
    }

    /**
     *   ,    
     *
     * @var array
     */
    private $variables = array();
}
