<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zroute.php 655 2009-04-28 05:22:28Z  $
 */


class zroute
{
    /**
     * @param array $config
     */
    public function __construct ($config) {
    	if (isset($config['url'])) {
    	    $this->url = $config['url'];
    	    unset($config['url']);
    	}
    	if (isset($config['pagepath'])) {
    	    $this->pagepath = $config['pagepath'];
    	    unset($config['pagepath']);
    	}
    	if (isset($config['module'])) {
    	    $this->module = $config['module'];
    	}
    	if (isset($config['params'])) {
	        $this->params = (array) $config['params'];
    	}
    }

    /**
     * @param string $url
     * @param string $pagepath
     * @return boolean
     */
    public function match ($url, $pagepath) {
        if (!empty($this->url)) {
        	if ($this->url != $url) {
                return false;
        	}
        } elseif (!empty($this->pagepath)) {
            if ($this->pagepath != $pagepath && substr($pagepath, 0, strlen($this->pagepath) + 1) !== $this->pagepath . '/') {
                return false;
            }
        }

        return array('module' => $this->module, 'params' => $this->params);
    }

    /**
     *    
     *
     * @return unknown
     */
    public function getPagepath () {
    	return $this->pagepath;
    }

    /**
     * @var string
     */
    private $url;

    /**
     * @var string
     */
    private $pagepath;

    /**
     * @var string
     */
    private $module;

    /**
     * @var array
     */
    private $params = array();
}
