<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zrouter.php 655 2009-04-28 05:22:28Z  $
 */

/** zroute */
require_once 'zengine/classes/zroute.php';

/**
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zrouter
{
    /**
     *  
     *
     * @var array
     */
    private $_routes = array();

    /**
     *  
     *
     * @param zconfig $routes  
     */
    public function __construct ()
    { }

    /**
     *  
     *
     * @param string $name
     * @param zroute $route
     * @return zrouter
     */
    public function addRoute ($name, zroute $route) {
    	$this->_routes[$name] = $route;
    	return $this;
    }

    /**
     *     <code>$name</code>
     *
     * @param string $name
     * @return zrouter
     */
    public function removeRoute ($name) {
    	if (isset($this->_routes[$name])) {
    	    unset($this->_routes[$name]);
    	}
    	return $this;
    }

    /**
     *     <code>$name</code>
     *
     * @param string $name
     * @return zroute
     */
    public function getRoute ($name) {
    	if (isset($this->_routes[$name])) {
    	    return $this->_routes[$name];
    	}

    	return null;
    }

    /**
     *        
     *
     * @param string $url
     * @return zpage
     */
    public function route ($url) {
        /**
         *   
         *
         * @todo     ,      404 
         */
        if (substr($url, 0, strlen(zengine::getInstance()->getBaseUri())) == zengine::getInstance()->getBaseUri()) {
            $url = substr($url, strlen(zengine::getInstance()->getBaseUri()) - 1);
        }

        //    
        $uri = $url;

        /**
         *    
         */
        $isPage = false;
        $pagepath = $uri;
        $ext = zengine::getInstance()->config()->get('url.extension');
        if (!empty($ext) && substr($pagepath, - strlen($ext) - 1) == '.' . $ext) {
            $pagepath = substr($uri, 0, strlen($pagepath) - strlen($ext) - 1);
            $isPage = true;
        }

        /**
         *   ,    ,   
         *    
         */
        $arModule = null;
        foreach (array_reverse($this->_routes) as $route) {
        	if (false !== ($arModule = $route->match($url, $pagepath))) {
                $zmodule = zengine::getModule($arModule['module']);
                if ($zmodule) {
                    if (is_array($arModule['params'])) {
                        $zmodule->setParams($arModule['params']);
                    }
                    $zmodule->setParam('isPage', $isPage);
                    $zmodule->setParam('basePagepath', $route->getPagepath());
                    return $zmodule->getPage($pagepath);
                }
        	}
        }

        return null;
    }
}
