<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zsidebar.php 655 2009-04-28 05:22:28Z  $
 */


/**
 *    
 *
 * @package    zengine
 * @subpackage Widgets
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zsidebar
{
    public function __construct ($params = array()) {
    	$this->params = array_merge($this->params, $params);
    }

    /**
     *    
     *
     * @param string $id
     * @param zwidget $widget
     * @return zsidebar
     */
    public function addWidget (zwidget $widget) {
    	$this->widgets[$widget->getId()] = $widget;
    	return $this;
    }

    /**
     *    
     *
     * @param string $id
     * @return zsidebar
     */
    public function removeWidget ($id) {
        if (isset($this->widgets[$id])) {
    	   unset($this->widgets[$id]);
        }
    	return $this;
    }

    /**
     *    
     *
     *
     */
    public function display () {
    	foreach ($this->widgets as $id => $widget) {
    	    /* @var $widget zwidget */
    	    $widget->display($this->params);
    	}
    }

    /**
     *   
     *
     * @var array
     */
    private $params = array(
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => "</li>\n",
        'before_title' => '<h2 class="widgettitle">',
        'after_title' => "</h2>\n",
    );

    /**
     *  
     *
     * @var array
     */
    private $widgets = array();
}
