<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zsource.php 662 2009-04-28 10:23:33Z lks $
 */


/**
 *   
 *
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
interface zsource {
    /**
     *     $pagepath     
     *
     * @param string $pagepath
     * @return boolean
     */
    public function delete ($pagepath);

    /**
     *       ,  
     *  content.     -   .
     *
     * @param string $parent    ,     
     * @return array
     */
    public function getAllPages ($parent = '');

    /**
     *        ,  
     *   $taguri
     *
     * @param string $taguri  
     * @return array
     */
    public function getPagesByTagUri ($taguri);

    /**
     *    
     *
     * @param string $pagepath    
     * @return array
     */
    public function getChildren ($pagepath);

    /**
     *     zmenu    
     *
     * @return zmenu
     */
    public function getMenu ();

    /**
     *    ,      ,
     *      
     *
     *     :
     * <code>
     * array(
     *     array(
     *         'name' => '- ',
     *         'uri' => 'kakoi-to-teg',
     *         'count' => 5
     *     )
     * );
     * </code>
     * :
     *     name -  
     *     uri -  ,       
     *     count -  ,   
     *
     * @return array
     */
    public function listUsedTags ();

    /**
     *  true,   ,    - false
     *
     * @return boolean
     */
    public function exists ($pagepath);

    /**
     *    
     *
     *   :
     *      title -  
     *      body -  
     *
     *   
     *      keywords -   
     *      description -  
     *      heading -  
     *      menuitem -   
     *      template -  
     *
     * @param string $pagepath   
     * @return array    
     */
    public function load ($pagepath);

    /**
     *      
     *
     * @param string $pagepath   
     * @return int
     */
    public function mtime ($pagepath);

    /**
     *    
     *
     * @param string $content
     * @return array
     */
    public function parse ($content);

    /**
     *       $pagename.
     *
     * @param string $pagename   
     * @param array $properties    
     * @return boolean
     */
    public function save ($pagename, array $properties);

    /**
     *  
     *
     */
    public function beginTransaction ();

    /**
     *  ,    
     *
     */
    public function commit ();

    /**
     *  ,    
     *
     */
    public function rollBack ();

    /**
     *      
     *
     */
    public function update ();
}
