<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @subpackage ztemplate
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: functions.php 655 2009-04-28 05:22:28Z  $
 */


/**
 *        
 *    .
 *
 * ,       :
 *
 * <?php z_head(); ?>
 * <?php echo zengine::ztemplate()->head(); ?>
 * <?php echo $this->head(); ?>
 *
 *   -   ,   
 *     $this.
 */

/**
 *    head  html-
 */
function z_head () {
	echo zengine::ztemplate()->head();
}


/**
 *   
 */
function z_title () {
    echo zengine::ztemplate()->zpage->getTitle();
}

/**
 *   
 */
function z_h1 () {
    echo zengine::ztemplate()->zpage->getHeading();
}

/**
 *   
 */
function z_content () {
    echo zengine::ztemplate()->zpage->getBody();
}

/**
 *       
 *
 * @param string $sort   
 * @param strin $open
 * @param strin $line
 * @param strin $close
 */
function z_subpages ($sort = 'mtime desc', $open = '', $line = '<a href="#link">#title</a><p>#description</p>', $close = '') {
    $html = zengine::ztemplate()->zpage->getCache('z_subpages');
    if (false === $html) {
        $html = zengine::ztemplate()->subpages($sort, $open, $line, $close);
        zengine::ztemplate()->zpage->cacheIt('z_subpages', $html);
    }
    echo $html;
}

/**
 *    
 */
function z_menu () {
    $html = zengine::ztemplate()->zpage->getCache('z_menu');
    if (false === $html) {
	   $html = zengine::ztemplate()->menu('minimal');
	   zengine::ztemplate()->zpage->cacheIt('z_menu', $html);
    }
    echo $html;
}

/**
 *    
 */
function z_fullmenu () {
    $html = zengine::ztemplate()->zpage->getCache('z_fullmenu');
    if (false === $html) {
	   $html = zengine::ztemplate()->menu('expanded');
	   zengine::ztemplate()->zpage->cacheIt('z_fullmenu', $html);
    }
    echo $html;
}

/**
 *     cmsimple
 */
function cmsimple_menu () {
    $html = zengine::ztemplate()->zpage->getCache('cmsimple_menu');
    if (false === $html) {
        $html = zengine::ztemplate()->cmsimplemenu();
        zengine::ztemplate()->zpage->cacheIt('cmsimple_menu', $html);
    }
    echo $html;
}

/**
 *   
 */
function z_breadcrumbs () {
    $html = zengine::ztemplate()->zpage->getCache('breadcrumb');
    if (false === $html) {
        $html = zengine::ztemplate()->breadcrumb();
        zengine::ztemplate()->zpage->cacheIt('breadcrumb', $html);
    }
    echo $html;
}

/**
 *     
 */
function z_sitemap () {
    echo zengine::getModule('zsitemap')->getLink();
}

/** Zebrum Lite 1.0.9 */

/**
 *      
 */
function z_tags () {
    echo zengine::getModule('ztags')->getLink();
}

/**
 *    
 *
 * @param string $template   
 */
function z_pagetags ($template) {
    $html = zengine::ztemplate()->zpage->getCache('pagetags');
    if (false === $html) {
	   $html = zengine::ztemplate()->pagetags($template);
	   zengine::ztemplate()->zpage->cacheIt('pagetags', $html);
    }
    echo $html;
}

/**
 *   
 */
function z_tagcloud ($open = '<ul class="tagcloud">', $line = '<li><a href="#link">#title</a></li>', $close = '</ul>') {
    $html = zengine::zcache()->get('tagcloud');
    if (false === $html) {
        $html = zengine::ztemplate()->tagcloud($open, $line, $close);
        zengine::zcache()->put('tagcloud', $html);
    }
    echo $html;
}

/** Zebrum Lite 1.0.10 */

/**
 *  -    RSS-
 *
 */
function z_rsshead () {
    echo '<link rel="alternate" type="application/rss+xml" title="' . htmlspecialchars(zengine::config()->get('rss.title', 'My site')) . '" href="~zfull/rss.xml" />';
}

/**
 *   
 */
function z_compactmenu () {
    $html = zengine::ztemplate()->zpage->getCache('z_compactmenu');
    if (false === $html) {
       $html = zengine::ztemplate()->compactmenu();
       zengine::ztemplate()->zpage->cacheIt('z_compactmenu', $html);
    }
    echo $html;
}

/** Zebrm Lite 1.0.11 */

/**
 *      
 *
 * @param string $open
 * @param string $lineWithLink
 * @param string $lineWithoutLink
 * @param string $close
 * @param string $separator
 */
function z_pagenavigation ($open = '<div id="navigation"><span>:</span> ',
        $lineWithLink = '<a href="#link">#number</a>',
        $lineWithoutLink = '#number',
        $close = '</div>',
        $separator = ' | ') {
    $html = zengine::ztemplate()->zpage->getCache('z_pagenavigation');
    if (false === $html) {
        $html = zengine::ztemplate()->pagenavigation($open, $lineWithLink, $lineWithoutLink, $close, $separator);
        zengine::ztemplate()->zpage->cacheIt('z_pagenavigation', $html);
    }
    echo $html;
}

/** Zebrum Lite 1.1.0 */

/**
 *   
 *
 * @param string $before    
 * @param string $separator   
 * @param string $after    
 * @param boolean $show_latest  ,   
 */
function z_breadcrumb ($before = '', $separator = ' &gt; ', $after = '', $show_latest = true) {
    $html = zengine::ztemplate()->zpage->getCache('breadcrumb');
    if (false === $html) {
        $html = zengine::ztemplate()->breadcrumb($before, $separator, $after, $show_latest);
        zengine::ztemplate()->zpage->cacheIt('breadcrumb', $html);
    }
    echo $html;
}

