<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zwidget.php 656 2009-04-28 05:26:17Z lks $
 */


/**
 *    
 *
 * @package    zengine
 * @subpackage Widgets
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
/*abstract*/ class zwidget
{
    /**
     *  .     
     *
     */
    public function init ()
    { }

    /**
     *  
     *
     * @param string $name  
     * @param string $title  ,    
     */
    public function __construct ($name, array $params = array(), $classname = '') {
    	$this->id = $name;
    	$this->classname = empty($classname) ? 'widget_' . $name : $classname;
    	$this->params = array_merge($this->params, $this->defaults, $params);
    	$this->init();
    }

    /**
     *        
     *
     *   :
     *      before_widget - ,     
     *      after_widget - ,     
     *      before_title - ,      
     *      after_title - ,      
     *
     * @uses zwidget::displayContent()    
     */
    public function display (array $params) {
        $widget = array_merge($this->params, $params);
        $widget['before_widget'] = sprintf($widget['before_widget'], $this->getId(), $this->getClassname());

        echo $widget['before_widget'];
        if ($this->getParam('title')) {
            echo $widget['before_title'] . $this->getParam('title') . $widget['after_title'];
        }
        echo $this->displayContent();
        echo $widget['after_widget'];
    }

    /**
     *    
     *
     */
    public function displayContent () {
        if (isset($this->params['content'])) {
            echo $this->params['content'];
        } elseif (isset($this->params['callback']) && is_callable($this->params['callback'])) {
            $args = array();
            if (isset($this->params['callback_args']) && is_array($this->params['callback_args'])) {
                $args = $this->params['callback_args'];
            }
            echo call_user_func_array($this->params['callback'], $args);
        }
    }

    /**
     *   
     *
     * @var array
     */
    private $params = array(
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => "</li>\n",
        'before_title' => '<h2 class="widgettitle">',
        'after_title' => "</h2>\n",
    );

    /**
     *     
     *
     * @var array
     */
    protected $defaults = array();

    /**
     *  
     *
     * @var string
     */
    private $id;

    /**
     *   
     *
     * @return string
     */
    public function getId () {
    	return $this->id;
    }

    /**
     *     
     *
     * @var string
     */
    private $classname;

    /**
     *     
     *
     * @return string
     */
    public function getClassname () {
    	return $this->classname;
    }

    /**
     *    <code>$key</code>
     *
     * @param string $key
     * @param string $default
     * @return string
     */
    public function getParam ($key, $default = null) {
    	if (isset($this->params[$key])) {
    	    return $this->params[$key];
    	}

    	return $default;
    }

}
