<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: breadcrumb.php 655 2009-04-28 05:22:28Z  $
 */


/**
 *   
 *
 * @package    zengine
 * @subpackage zhelper
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zhelper_breadcrumb {
    /**
     *   
     *
     * @param string $before    
     * @param string $separator   
     * @param string $after    
     * @param boolean $show_latest  ,   
     */
    public function breadcrumb ($before = '', $separator = ' &gt; ', $after = '', $show_latest = true) {
        $items = array();
        $uri = $this->zpage->getPagepath();
        $zmenu = zengine::zsource()->getMenu();
        $nofollow = '';
        if (zengine::config()->get('breadcrumb.nofollow')) {
            $nofollow = ' rel="nofollow"';
        }

        if ($this->zpage->getProperty('breadcrumb')) {
            $items[] = $this->zpage->getProperty('breadcrumb');
        } else {
            $item = $zmenu->find($uri);
            if ($item) {
                /* @var $item zmenu */
                $items[] = $item->name;
                while ($item = $item->getParent()) {
                    if ($item->uri) {
                        $items[] = '<a href="' . $item->link . '"' . $nofollow . '>' . htmlspecialchars($item->name) . '</a>';
                    }
                }
            }
        }

        if ('/index' != $uri) {
            $mainpage = $zmenu->find('/index');
            if ($mainpage) {
                $items[] = '<a href="' . $mainpage->link . '"' . $nofollow . '>' . htmlspecialchars($mainpage->name) . '</a>';
            }
        }

        $items = array_reverse($items);

        if (!$show_latest) {
            array_pop($items);
        }

        if (count($items)) {
            echo $before . implode($separator, $items) . $after;
        }
    }
}
