<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: cmsimplemenu.php 662 2009-04-28 10:23:33Z lks $
 */


/**
 *      CMSimple
 *
 * @package    zengine
 * @subpackage zhelper
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zhelper_cmsimplemenu {
    /**
     *     CMSimple
     */
    public function cmsimplemenu () {
        $this->nofollow = '';
        if (zengine::config()->get('menu.nofollow')) {
            $this->nofollow = ' rel="nofollow"';
        }
        $this->pagepath = $this->zpage->getPagepath();

        echo '<ul class="menulevel1">';
        $this->displayItems(zengine::zsource()->getMenu(), 2);
        echo '</ul>';
    }

    /**
     *   
     *
     * @param zmenu $items
     */
    private function displayItems ($items, $level) {
        foreach ($items as $item) {
            if ($item->nomenuitem) {
                continue;
            }

            $suffix = '';
            if ($item->hasSubmenu()) {
                $suffix = 's';
            }
            if ($this->pagepath == $item->uri) {
                echo '<li class="sdoc' . $suffix . '">' . $item->name;
            } else {
                if (strpos($this->pagepath, $item->uri . '/') === 0 || strpos($item->uri, dirname($this->pagepath)) !== 0) {
                    echo '<li class="doc' . $suffix . '"><a href="' . $item->link . '"' . $this->nofollow . '>' . $item->name . '</a>';
                } else {
                    echo '<li class="doc' . $suffix . '"><a href="' . $item->link . '">' . $item->name . '</a>';
                }
            }
            if ($this->showSubmenu($item) && $item->hasSubmenu()) {
                echo '<ul class="menulevel' . $level . '">';
                $this->displayItems($item, $level + 1);
                echo '</ul>';
            }
            echo '</li>';
        }
    }

    /**
     *  ,       
     *
     * @param zmenu $item  
     * @return boolean
     */
    private function showSubmenu ($item) {
	    if (!$item->nosubmenu && ($item->uri == $this->pagepath || strpos($this->pagepath, $item->uri . '/') === 0)) {
	       return true;
	    }
    	return false;
    }

    /**
     *     
     *
     * @var string
     */
    private $nofollow;

    /**
     *    
     *
     * @var string
     */
    private $pagepath;
}
