<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: menu.php 662 2009-04-28 10:23:33Z lks $
 */


/**
 *   
 *
 * @package    zengine
 * @subpackage zhelper
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zhelper_menu {
    /**
     *  .   : expanded, minimal
     *
     * @param string $type  
     */
    public function menu ($type = 'expanded') {
        $this->nofollow = '';
        if (zengine::config()->get('menu.nofollow')) {
            $this->nofollow = ' rel="nofollow"';
        }
        $this->pagepath = $this->zpage->getPagepath();

        $this->type = $type;
        echo '<ul id="menu">';
        $this->displayItems(zengine::zsource()->getMenu());
        echo '</ul>';
    }

    /**
     *   
     *
     * @param zmenu $items
     */
    private function displayItems ($items) {
        foreach ($items as $item) {
            if ($item->nomenuitem) {
                continue;
            }

            if ($this->pagepath == $item->uri) {
                echo '<li class="current">' . $item->name;
            } else {
                if (strpos($this->pagepath, $item->uri . '/') === 0 || strpos($item->uri, dirname($this->pagepath)) !== 0) {
                    echo '<li><a href="' . $item->link . '"' . $this->nofollow . '>' . $item->name . '</a>';
                } else {
                    echo '<li><a href="' . $item->link . '">' . $item->name . '</a>';
                }
            }
            if ($this->showSubmenu($item) && $item->hasSubmenu()) {
                echo '<ul>';
                $this->displayItems($item);
                echo '</ul>';
            }
            echo '</li>';
        }
    }

    /**
     *  ,       
     *
     * @param zmenu $item  
     * @return boolean
     */
    private function showSubmenu ($item) {
        if ($item->nosubmenu) {
            return false;
        }
    	if ($this->type == 'minimal') {
    	    if ($item->uri == $this->pagepath || strpos($this->pagepath, $item->uri . '/') === 0) {
    	       return true;
    	    } else {
    	        return false;
    	    }
    	}
    	return true;
    }

    /**
     *  ,   
     *
     * @var string
     */
    private $type;

    /**
     *     
     *
     * @var string
     */
    private $nofollow;

    /**
     *    
     *
     * @var string
     */
    private $pagepath;
}
