<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zrss.php 655 2009-04-28 05:22:28Z  $
 */

/**
 *    rss-
 *
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @see        http://sitemaps.org/protocol.php
 */
class zmodule_zrss extends zmodule
{
    /**
     *   ,   ,   
     *
     * @return string
     */
    public function getPage ($uri) {
        header('Content-Type: application/rss+xml; charset=' . zengine::config()->get('engine.charset'));
        /**
         * @todo   RSS   XMLWriterx
         */
        $xml = zengine::zcache()->get('rss');
        if (false === $xml) {
            $xml = $this->plainCreate();
            zengine::zcache()->put('rss', $xml);
        }
        echo $xml;
        exit;
    }

    /**
     *     XMLWriter,   ,   .
     *
     * @return string
     */
    private function plainCreate () {
        ob_start();

        /**
         * @todo   
         */
        echo '<?xml version="1.0" encoding="' . zengine::config()->get('engine.charset') . '"?>
<rss version="2.0">
<channel>
<title><![CDATA[' . zengine::config()->get('rss.title', 'My site') . ']]></title>
<description><![CDATA[' . zengine::config()->get('rss.description', 'Description') . ']]></description>
<language>ru</language>
<link>http://' . $_SERVER['HTTP_HOST'] . '/</link>
<pubDate>' . date('r', strtotime(ZENGINE_NOW)) . '</pubDate>
<ttl>60</ttl>';

        /**
         *     ,    
         * 
         */
        $pages = array();
        $sections = preg_split("%\s*,\s*%", zengine::config()->get('rss.sections', ''), null, PREG_SPLIT_NO_EMPTY);
        if (empty($sections)) {
            $sections = array('');
        }

        foreach ($sections as $section) {
            foreach (zengine::zsource()->getAllPages($section) as $pagepath) {
                $properties = zengine::zsource()->load($pagepath);
                $properties['pagepath'] = $pagepath;
                if ($properties['publish'] > ZENGINE_NOW) {
                    continue;
                }
                $pages[] = zpage::createPage($properties);
            }
        }

        /**
         *  
         */
        $sorter = new zpagesorter(zengine::config()->get('rss.order', 'sort asc, publish desc, title desc'));
        $sorter->sort($pages);

        /**
         *   
         */
        $limit = zengine::config()->get('rss.limit', 10);
        foreach ($pages as $page) {
            /* @var $page zpage */
            echo '<item>';
            $link = 'http://' . $_SERVER['HTTP_HOST'] . $page->getLink();
            echo '<title><![CDATA[' . $page->getTitle() . ']]></title>';
            echo '<description><![CDATA[' . $page->getDescription() . ']]></description>';
            echo '<link>' . $link . '</link>';
            echo '<pubDate>' . date('Y-m-d\TH:i:s+00:00', strtotime($page->getProperty('publish'))) . '</pubDate>';
            echo '</item>';
            if (!--$limit) {
                break;
            }
        }

        echo '</channel>
</rss>';
        $rss = ob_get_contents();
        ob_end_clean();
        return $rss;
    }
}
