<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zsitemap.php 659 2009-04-28 07:55:56Z lks $
 */


/**
 *     CMSimple
 *
 * @package    zengine
 * @subpackage zmodule
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zmodule_zsitemap extends zmodule {
    /**
     *     
     *
     * @return string
     */
    public function getLink () {
        if (zengine::getInstance()->getFilepath() == '/sitemap') {
            return $this->loadPage()->getMenu();
        }

        return '<a href="' . $this->loadPage()->getLink() .'">' . $this->loadPage()->getMenu() . '</a>';
    }

    /**
     *       CMSimple
     *
     * @param string $uri   
     * @return zpage
     */
    public function getPage ($uri) {
        /**
         *      
         */
        $zpage = $this->loadPage();

        /**
         *  setBody      
         */
        $zpage->setBody($this->getBody());
        return $zpage;
    }

    /**
     *     
     *
     * @return string
     */
    private function getBody () {
        ob_start();
        echo '<ul class="sitemaplevel1">';
        $this->displayItems(zengine::zsource()->getMenu(), 2);
        echo '</ul>';
        $body = ob_get_contents();
        ob_end_clean();
        return $body;
    }

    /**
     *   
     *
     * @param zmenu $items
     * @param int $level
     */
    private function displayItems ($items, $level) {
        foreach ($items as $item) {
            $suffix = '';
            if ($item->hasSubmenu()) {
                $suffix = 's';
            }
            echo '<li class="doc' . $suffix . '"><a href="' . $item->link . '">' . $item->name . '</a>';
            if (count($item->subpages) > 1) {
                echo ', <small>. ';
                $pages = array();
                for ($i = 2, $n = count($item->subpages); $i <= $n; ++$i) {
                    $pages[] = '<a href="' . $item->subpages[$i] . '">' . $i . '</a>';
                }
                echo implode(', ', $pages);
                echo '</small>';
            }
            if ($item->hasSubmenu()) {
                echo '<ul class="sitemaplevel' . $level . '">';
                $this->displayItems($item, $level + 1);
                echo '</ul>';
            }
            echo '</li>';
        }
    }

    /**
     *       
     *
     * @return zpage
     */
    private function loadPage () {
        if (isset($this->_zpage)) {
            return $this->_zpage;
        }
        $properties = array();
        $properties['menu'] = $properties['breadcrumb'] = $properties['title'] = $this->getParam('title', 'Site map');
        $properties['pagepath'] = '/sitemap';
        $properties['filter'] = 'asis';
        $this->_zpage = zpage::createPage($properties);
        return $this->_zpage;
    }

    /**
     *   
     *
     * @var zpage
     */
    private $_zpage;
}