<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: ztags.php 662 2009-04-28 10:23:33Z lks $
 */


/**
 *     CMSimple
 *
 * @package    zengine
 * @subpackage zmodule
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zmodule_ztags extends zmodule {
    /**
     *     
     *
     * @param string $tag
     * @return string
     */
    public function getTagLink ($tag) {
    	return '~/tags/' . zutils::filename($tag);
    }

    /**
     *     
     *
     * @return string
     */
    public function getLink () {
        if (zengine::getInstance()->getFilepath() == '/tags') {
            return $this->loadPage()->getMenu();
        }

        return '<a href="' . $this->loadPage()->getLink() .'">' . $this->loadPage(true)->getMenu() . '</a>';
    }

    /**
     *       CMSimple
     *
     * @param string $uri   
     * @return zpage
     */
    public function getPage ($uri) {
        //      ,    
        // 
        if ($uri == $this->getParam('basePagepath') && !$this->getParam('isPage')) {
            return null;
        }

        $uri = substr($uri, strlen($this->getParam('basePagepath')) + 1);

        /**
         *      
         */
        $zpage = $this->loadPage();

        /**
         *  setBody      
         */
        $body = $this->getBody($uri);
        if (null === $body) {
            return null;
        }

        $zpage->setBody($body);
        return $zpage;
    }

    /**
     *     
     *
     * @return string
     */
    private function getBody ($tagUri) {
        $tagsPage = $this->loadPage();

        ob_start();
        if (!empty($tagUri)) {
            $tags = zengine::zsource()->listUsedTags();

            $desc = null;
            foreach ($tags as $tag) {
                if ($tag['uri'] == $tagUri) {
                    $desc = $tag;
                    break;
                }
            }

            if ($desc) {
                $tagsPage->setProperty('title', $desc['name']);
                $tagsPage->setProperty('breadcrumb', $desc['name']);


                echo $tagsPage->getProperty('__open', '');
                $line = $tagsPage->getProperty('__line', '<p><a href="#link">#title</a><br />#description</p>');
                foreach (zengine::zsource()->getPagesByTagUri($desc['uri']) as $pagepath) {
                    $page = zpage::load($pagepath);
                    /* @var $page zpage */
                    $description = $page->getDescription();
                    if (empty($description)) {
                        $description = strip_tags(substr(ltrim($page->getBody(), " \n"), 0, strpos($page->getBody(), "\n")));
                    } else {
                        $description = $description;
                    }
                    $from = array('#link', '#title', '#description');
                    $to = array($page->getLink(), $page->getTitle(), $description);
                    echo str_replace($from, $to, $line);
                }
                echo $tagsPage->getProperty('__close', '</p>');
            } else {
                ob_end_clean();
                return null;
            }
        } else {
            echo $tagsPage->getBody();
            $this->tagcloud();
        }
        $body = ob_get_contents();
        ob_end_clean();
        return $body;
    }

    /**
     *   
     *
     * @deprecated
     */
    public function tagcloud () {
        $tags = zengine::zsource()->listUsedTags();
        uasort($tags, array($this, 'tagcmp'));
        echo '<ul class="tagcloud">';
        foreach ($tags as $link => $tag) {
            echo '<li><a href="' . $this->getTagLink($link) . '">' . $tag['name'] . '</a></li>';
        }
        echo '</ul>';
    }

    /**
     *    
     *
     * @param array $left
     * @param array $right
     * @return int
     */
    public function tagcmp ($left, $right) {
        if ($left['count'] == $right['count']) {
            return strcmp($left['name'], $right['name']);
        }
        return ($left['count'] > $right['count'] ? -1 : 1);
    }

    /**
     *       
     *
     * @return zpage
     */
    private function loadPage ($reload = false) {
        if (isset($this->_zpage) && !$reload) {
            return $this->_zpage;
        }

        $properties = array();
        $properties['breadcrumb'] = $properties['title'] = $this->getParam('title', 'Tags');
        $properties['pagepath'] = $this->getParam('basePagepath');
        $properties['filter'] = 'asis';
        $this->_zpage = zpage::createPage($properties);
        return $this->_zpage;
    }

    /**
     *   
     *
     * @var zpage
     */
    private $_zpage;
}