<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: requirements.php 146 2008-08-22 06:13:11Z lks $
 */


if (version_compare(PHP_VERSION, '5.1.4', '<')) {
    echo '<pre>Zebrum Lite requires PHP 5.1.4 or later. You are using PHP ' . PHP_VERSION . '.</pre>';
    exit;
}

$REQUIREMENTS_FAILS = array();
if (function_exists('apache_get_modules') && !in_array('mod_rewrite', apache_get_modules())) {
    $REQUIREMENTS_FAILS[] = 'Zebrum Lite requires Apache module mod_rewrite. Please install required module.';
}

if (!extension_loaded('spl')) {
    $REQUIREMENTS_FAILS[] = 'Zebrum Lite requires PHP extension SPL. This extension is available and compiled by default in PHP 5.0.0, but it seems to be disabled. Please enable it and try again.';
}

if (!class_exists('DirectoryIterator', false)) {
    $REQUIREMENTS_FAILS[] = 'It\'s strange, spl is loaded but class DirectoryIterator still doesn\'t exists. Please contact us by email <a href="mailto:support@zebrum.ru">support@zebrum.ru</a>.';
}

if ($REQUIREMENTS_FAILS) {
    echo '<pre>' . implode("\r\n", $REQUIREMENTS_FAILS) . '</pre>';
    exit;
}

/**
 *    iconv?
 */
if (!extension_loaded('iconv') && !function_exists('iconv')) {
    function iconv ($from, $to, $content) {
        echo '<pre>Error: You are trying to convert charsets from "' . $from . '" to "' . $to . '", but you have no ICONV module. To use this module, the PHP must be built with the following configure line: --with-iconv[=DIR]. Please enable it and try again. If you can\'t, please, use UTF-8 for all pages, settings.</pre>';
        return $content;
    }
}
