<?php
/**
 * Zebrum Lite
 *
 * 
 *
 *      ,    
 *    LICENSE.txt.
 *           URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: images.php 655 2009-04-28 05:22:28Z  $
 */

/** ztransform */
require_once 'zengine/classes/ztransform.php';

/** zpage */
require_once 'zengine/classes/zpage.php';

/**
 *     
 *
 * @package    zengine
 * @subpackage ztransform
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class ztransform_images implements ztransform {
    /**
     *   
     *
     */
    public function __construct () {
        //$tag = zengine::ztemplate()->loadTpl('transform_images.tpl');
	    if (!empty($tag)) {
	        $this->_tag = $tag;
	    }
    }

    /**
     *    .
     *
     * @param zpage $zpage  
     */
    public function transform (zpage $zpage) {
        $this->_images = $this->getImages($zpage);
        $this->_cursor = 0;

        $content = $zpage->getProperty('body');
        $content = preg_replace_callback("%<img(?::([^\s>]+?))?(\s[^>]*)?/?>%i", array($this, 'insertImage'), $content);
        //       ,       
        if (!$this->_cursor && $this->_images) {
            $content = $this->insertImage() . $content;
        }
        $zpage->setProperty('body', $content);
    }

    /**
     *   
     *
     * @param array $match
     * @return string
     */
    private function insertImage ($matches = array()) {
        //       
        $attributes = array();
        if (!empty($matches[2])) {
            $attributes = $this->parseAttributes($matches[2]);
            //    ,     
            if (isset($attributes['#src'])) {
                if (substr($attributes['#src'], 0, 2) == './') {
                    //      
                    return str_replace($attributes['#src'], substr($attributes['#src'], 1), $matches[0]);
                } else {
                    return $matches[0];
                }
            }
        }

        //  
        $image = array();
        if (!empty($matches[1])) {
            $image = $this->getImageArray($matches[1]);
        } else {
            if (isset($this->_images[$this->_cursor])) {
                $image = $this->_images[$this->_cursor];
            }

            //   
            ++$this->_cursor;
        }

        //       ,   
        if (empty($image)) {
            return '';
        }

        //     ,   
        $image['#align'] = 'left';
        $image['#alt'] = '';
        if (!empty($attributes)) {
            $image = array_merge($image, $attributes);
        }

        //  
    	$result = str_replace(array_keys($image), array_values($image), $this->_tag);

    	//   ,  ,   
        return preg_replace("%\s+(?!alt)([a-z]+)\s*=\s*\"#[a-z]+\"%i", '', $result);
    }

    /**
     *       
     *
     * @param string $string
     * @return array
     */
    private function parseAttributes ($string) {
    	$attributes = array();
    	if (preg_match_all("%([a-z]+)\s*=\s*(?:\"([^\"]+)\"|([^\s]+))%Ui", $string, $matches, PREG_PATTERN_ORDER)) {
    	    foreach ($matches[1] as $key => $name) {
    	        $value = $matches[2][$key];
    	        if (empty($value)) {
    	            $value = $matches[3][$key];
    	        }
    	        $attributes['#' . strtolower($name)] = $value;
    	    }
    	}
    	return $attributes;
    }

    /**
     *   ,     
     * .         
     *
     * [uri] => '~/images/'
     * [path]
     *
     * @param zpage $zpage
     * @return array
     */
    private function getImages (zpage $zpage) {
    	$images = array();
    	foreach (explode(',', $zpage->getProperty('images')) as $name) {
    	    $name = trim($name);
    	    if (!empty($name)) {
    	       $images[] = $this->getImageArray($name);
    	    }
    	}
    	return $images;
    }

    /**
     *        
     *
     * @param string $name
     * @return array
     */
    private function getImageArray ($name) {
        $image = array();
        if ($name[0] != '~') {
            $filename = '/images/' . $name;
        } else {
            $filename = substr($name, 1);
        }
        $filepath = ZENGINE_HOMEDIR . $filename;
        if (file_exists($filepath)) {
            $stat = getimagesize($filepath);
            if ($stat) {
                $image['#src'] = '~' . $filename;
                $image['#width'] = $stat[0];
                $image['#height'] = $stat[1];
                $image['#dimensions'] = $stat[3];
            }
        }
        return $image;
    }


    /**
     *   ,   
     *
     * @var array
     */
    private $_images;

    /**
     *    
     *
     * @var int
     */
    private $_cursor = 0;

    /**
     *      
     *
     * @var string
     */
    private $_tag = '<img src="#src" width="#width" height="#height" align="#align" title="#title" alt="#alt" />';
}
